; gpasm -a inhx32 -p p18f47k40 flash_examples.asm
; compiles OK gpasm, mpasm

#include <p18f47k40.inc>

        cblock 0
	CODE_ADDR_UPPER  	
	CODE_ADDR_HIGH  
	CODE_ADDR_LOW	  
	WORD_EVEN	  
	WORD_ODD	  
	BUFFER_ADDR_HIGH 
	BUFFER_ADDR_LOW  
	NEW_DATA_LOW	 
	NEW_DATA_HIGH	  
	COUNTER          
	COUNTER2         
	BlockSize        
	EE_ADDRL        
	EE_ADDRH         
	EE_DATA          
	endc
	
        ORG 0	
;--------------------------------------------------------------------	
; Eample 11-1: Reading a program flash memory word ------------------
;--------------------------------------------------------------------
	
	MOVLW  	CODE_ADDR_UPPER	 ; Load TBLPTR with the base
	MOVWF	TBLPTRU		 ; address of the word
	MOVLW	CODE_ADDR_HIGH
	MOVWF	TBLPTRH
	MOVLW	CODE_ADDR_LOW
	MOVWF	TBLPTRL
READ_WORD
	TBLRD*+			 ; read into TABLAT and increment
	MOVF	TABLAT, W	 ; get data
	MOVWF	WORD_EVEN
	TBLRD*+			 ; read into TABLAT and increment
	MOVWF	TABLAT, W	 ; get data
	MOVF	WORD_ODD

;-----------------end reading program flash memoy word---------------

;--------------------------------------------------------------------
; EXAMPLE 11-2: NVM UNLOCK SEQUENCE ---------------------------------
;--------------------------------------------------------------------

	BCF INTCON,GIE		 ; Recommended so sequence is not interrupted
	BANKSEL NVMCON1
	BSF NVMCON1,WREN 	 ; Enable write/erase
	MOVLW 55h 		 ; Load 55h
	
	MOVWF NVMCON2 		 ; Step 1: Load 55h into NVMCON2
	MOVLW H'AA' 		 ; Step 2: Load W with AAh
	MOVWF NVMCON2 		 ; Step 3: Load AAh into NVMCON2
	BSF INTCON,WR 		 ; Step 4: Set WR bit to begin write/erase
	BSF INTCON,GIE 		 ; Re-enable interrupts

; Note 1: Sequence begins when NVMCON2 is written; steps 1-4 must occur 
;	in the cycle-accurate order shown. If the timing of the steps
;	1 to 4 is corrupted by an interrupt or a  debugger Halt, the action
;	will not take place.

;     2: Opcodes shown are illustrative; any instruction that has the 	indicated effect may be used.

;------------------------End Unlock Operation------------------------

;--------------------------------------------------------------------
; EXAMPLE 11-3: ERASING A PROGRAM FLASH MEMORY BLOCK ----------------
;--------------------------------------------------------------------

; This sample row erase routine assumes the following:
; 1. A valid address within the erase row is loaded in variables TBLPTR register
; 2. ADDRH and ADDRL are located in common RAM (locations 0x70 - 0x7F)

	MOVWF   CODE_ADDR_UPPER	 ; load TBLPTR with the base
	MOVWF	TBLPTRU		 ; address of the memory block
	MOVLW	CODE_ADDR_HIGH
	MOVWF	TBLPTRH
	MOVLW	CODE_ADDR_LOW
	MOVWF	TBLPTRL 	
ERASE_BLOCK	
	BCF	NVMCON1, NVMREG0 ;nvmcon1 = b'10010100'
	BSF	NVMCON1, NVMREG1
	BSF	NVMCON1, WREN
	BSF	NVMCON1, FREE
	BCF	INTCON, GIE      ; dissable interrupts
;Required 
;Sequence
	MOVLW	55h
	MOVWF	NVMCON2	
	MOVLW	H'AA'
	MOVWF	NVMCON2
	BSF	NVMCON1, WR
	BSF 	INTCON, GIE

;-----------------end erasing an flash memory block------------------

;--------------------------------------------------------------------
; EXAMPLE 11-4: WRITING TO PROGRAM FLASH MEMORY ---------------------
;--------------------------------------------------------------------
	MOVLW	D'64'	         ; number of bytes in erase block
	MOVWF	COUNTER		 ;+
	MOVLW	BUFFER_ADDR_HIGH ; point to buffer
	MOVWF	FSR0H            ;
	MOVLW	BUFFER_ADDR_LOW  ;
	MOVWF	FSR0L            ;
	MOVLW	CODE_ADDR_UPPER	 ;+ Load TBLPTR with the base
	MOVWF	TBLPTRU		 ;+ address of the memory block
	MOVLW	CODE_ADDR_HIGH   ;+
	MOVWF	TBLPTRH    	 ;+
	MOVLW	CODE_ADDR_LOW    ;+
	MOVWF 	TBLPTRL		 ;+
READ_BLOCK	
	TBLRD*+	 		 ;- read into TABLAT, and inc
	MOVF	TABLAT, W 	 ;- get data
	MOVWF	POSTINC0	 ;- store data
	DECFSZ	COUNTER		 ;- done?
	BRA 	READ_BLOCK	 ;- repeat
MODIFY_WORD
	MOVLW	BUFFER_ADDR_HIGH ;+ point to buffer
	MOVWF	FSR0H		 ;+
	MOVLW	BUFFER_ADDR_LOW	 ;+
	MOVWF	FSR0L		 ;+
	MOVLW	NEW_DATA_LOW	 ;- update buffer word
	MOVWF	POSTINC0	 ;-
	MOVLW	NEW_DATA_HIGH	 ;-
	MOVWF	INDF0 		 ;-
ERASE_BLOCK
	MOVLW	CODE_ADDR_UPPER	 ; load TBLPTR with the base
	MOVWF	TBLPTRU		 ; address of the memory block
	MOVLW	CODE_ADDR_HIGH
	MOVWF	TBLPTRH
	MOVLW	CODE_ADDR_LOW
	MOVWF	TBLPTRL
	BCF	NVMCON1, NVMREG0 ; point to Program Flash Memory
	BSF	NVMCON1, NVMREG1 ; point to Program Flash Memory
	BSF	NVMCON1, WREN	 ; enable write to memory
	BSF	NVMCON1, FREE 	 ; enable Erase operation
	BCF	INTCON, GIE	 ; disable interrupts
	MOVLW	55h
;Required
;Sequence
	MOVWF	NVMCON2		 ; write 55h
	MOVLW	H'AA'
	MOVWF	NVMCON2		 ; write 0AAh	
	BSF	NVMCON1, WR	 ; start erase (CPU stall)
	BSF	INTCON, GIE	 ; re-enable interrupts
	TBLRD*-			 ; dummy read decrement
	MOVLW	BUFFER_ADDR_HIGH ; point to buffer
	MOVWF	FSR0H		
	MOVLW	BUFFER_ADDR_LOW
	MOVWF	FSR0L
WRITE_BUFFER_BACK
	MOVLW	BlockSize	 ; number of bytes in holding register
	MOVWF	COUNTER
	MOVLW	D'64'/ BlockSize ; number of write blocks in 64 bytes
	MOVWF	COUNTER2
WRITE_BYTE_TO_HREGS
	MOVF	POSTINC0, W	 ; get low byte of buffer data
	MOVWF	TABLAT		 ; present data to table latch
	TBLWT+*			 ; write data, perform a short write
				 ; to internal TBLWT holding register.
	DECFSZ	COUNTER		 ; loop until holding registers are full
	BRA	WRITE_BYTE_TO_HREGS
PROGRAM_MEMORY
	BCF	NVMCON1, NVMREG0 ; point to Program Flash Memory
	BSF	NVMCON1, NVMREG1 ; point to Program Flash Memory
	BSF	NVMCON1, WREN	 ; enable write to memory
	BCF	NVMCON1, FREE	 ; enable write to memory
	BCF	INTCON, GIE	 ; disable interrupts
	MOVLW	55h
;Required
;Sequence
	MOVWF	NVMCON2
	MOVLW	H'AA'		 ; write 55h
	MOVWF	NVMCON2		 ; write AAh
	BSF	NVMCON1, WR	 ; start program (CPU stall)
	DECFSZ	COUNTER2	 ; repeat for remaining write blocks
	BRA	WRITE_BYTE_TO_HREGS
	BSF	INTCON, GIE	 ; re-enable interrupts
	BCF	NVMCON1, WREN	 ; disable write to memory

;-------------------end witing to flash program memory---------------

;--------------------------------------------------------------------
; EXAMPLE 11-5: DATA EEPROM READ ------------------------------------
;--------------------------------------------------------------------

; Data Memory Address to read
	BCF NVMCON1, NVMREG0 	 ; Setup Data EEPROM Access
	BCF NVMCON1, NVMREG1	 ; Setup Data EEPROM Access
	MOVF EE_ADDRL, W
	MOVWF NVMADRL		 ; Setup Address low byte
	MOVF EE_ADDRH, W
	MOVWF NVMADRH		 ; Setup Address high byte (if applicable)
	BSF NVMCON1, RD		 ; Issue EE Read
	MOVF NVMDAT, W		 ; W = EE_DATA

;------------------end eeprom read-----------------------------------

;--------------------------------------------------------------------
; EXAMPLE 11-6: DATA EEPROM WRITE -----------------------------------
;--------------------------------------------------------------------

; Data Memory Address to write
	BCF	NVMCON1, NVMREG0 ; Setup Data EEPROM access
	BCF	NVMCON1, NVMREG1 ; Setup Data EEPROM access
	MOVF 	EE_ADDRL, W
	MOVWF 	NVMADRL		 ; Setup Address low byte
	MOVF 	EE_ADDRH, W
	MOVWF 	NVMADRH		 ; Setup Address high byte (if applicable)
; Data Memory Value to write
	MOVF 	EE_DATA, W 
	MOVWF 	NVMDAT
; Enable writes
	BSF	NVMCON1, WREN
; Disable interrupts
	BCF	INTCON, GIE
; Required unlock sequence
	MOVLW	55h
	MOVWF	NVMCON2
	MOVLW	H'AA'
	MOVWF	NVMCON2
; Set WR bit to begin write
	BSF	NVMCON1, WR
; Wait for write to complete
	BTFSC	NVMCON1, WR
	BRA	$-2
; Enable INT
	BSF	INTCON, GIE
; Disable writes
	BCF	NVMCON1, WREN

;-------------------end eeprom write---------------------------------

;--------------------------------------------------------------------
; EXAMPLE 11-7:DATA EEPROM REFRESH ROUTINE --------------------------
;--------------------------------------------------------------------

	CLRF	NVMADRL		 ; Clear address low byte register
	CLRF	NVMADRH		 ; Clear address high byte register (if applicable)
	BCF	NVMCON1, NVMREG0 ; Set access for EEPROM
	BCF	NVMCON1, NVMREG1 ; Set access for EEPROM
	SETF	NVMDAT		 ; Load 0xFF to data register
	BCF	INTCON, GIE	 ; Disable interrupts
	BSF 	NVMCON1, WREN	 ; Enable writes
Loop				 ; Loop to refresh array
	MOVLW	0x55		 ; Initiate unlock sequence
	MOVWF	NVMCON2
	MOVLW	0xAA
	MOVWF	NVMCON2
	BSF	NVMCON1, WR	 ; Set WR bit to begin write
	BTFSC	NVMCON1, WR	 ; Wait for write to complete
	BRA	$-2
	INCFSZ	NVMADRL, F	 ; Increment address low byte
	BRA 	Loop		 ; Not zero, do it again

; The following 4 lines of code are not needed if the part doesn't have NVMADRH register
	INCF	NVMADRH, F	 ; Decrement address high byte
	MOVLW	0x03		 ; Move 0x03 to working register
	CPFSGT	NVMADRH		 ; Compare address high byte with working register
	BRA	Loop		 ; Skip if greater than working register
				 ; Else go back to erase loop

	BCF	NVMCON1, WREN	 ; Disable writes
	BSF	INTCON, GIE	 ; Enable interrupts

;--------------------end eeprom refresh-------------------------------
	END




















